<?php
/**
 * handels all around the groups (desk, save, edit)
 * @author sven kronshage
 */
class Group{
	/**
	 * @var string tpl path
	 */
	private $tpl;
	/**
	 * @var object database
	 */
	private $db;
	/**
	 * @var string database-prfix
	 */
	private $db_prefix = '';
	/**
	 * 
	 * @var string get param
	 */
	public $page;
	
	/**
	 * @var array for language data
	 */
	private $lang;
	
	public function __construct(){
		global $wpdb;
		$this->db 			= &$wpdb;
		$this->page 		= 'admin.php?page='.$_GET['page'].'&action=';
		$this->db_prefix 	= $this->db->prefix.'datasheet_';
		$this->tpl 			= DS_PLUGIN_PATH_TPL;
		include DS_PLUGIN_PATH.'lang/'.WPLANG.'.php';
		$this->lang = $lang;
	}
	/**
	 * a method to switch the group content
	 */
	public function groups(){
		switch( $_GET['action'] ){
			case 'new':
				if( $_POST['save'] )
					$save = $this->saveGroup();
				include $this->tpl.'group-process.php';
			break;
			case 'edit':
				if( $_POST['save'] )
					$save = $this->saveGroup();
				$this->updateGroup();
				include $this->tpl.'group-process.php';
			break;
			case 'delete':
				$sql = 'DELETE FROM `'.$this->db_prefix.'groups` WHERE `'.$this->db_prefix.'groups`.`id` = '.$_GET['group'];
				$this->db->query( $sql ); 
			default:
				$results = $this->db->get_results( "SELECT * FROM  `".$this->db_prefix."groups` ORDER BY `sort`" );
				include $this->tpl.'group-desk.php';
			break;
		}
		
	} 
	/**
	 * a method to validate a group update
	 */
	private function updateGroup(){
		$result = $this->db->get_results( "SELECT * FROM  `".$this->db_prefix."groups` WHERE `id`=".$_GET['group'] );
		$_POST['group_name'] 		= $result[0]->title;
		$_POST['group_frt_name'] 	= $result[0]->frontend_title;
		$_POST['page'] 				= $result[0]->page;
		$_POST['context'] 			= $result[0]->context;
		$_POST['priority'] 			= $result[0]->priority;
		$_POST['group_visible'] 	= $result[0]->visible_frontend;
		
	}
	/**
	 * saves group data to database
	 */
	private function saveGroup(){
		global $current_user;
		if( $_GET['action'] == 'new' ){
			$sql = "INSERT INTO  `".$this->db_prefix."groups` (
				`id` ,
				`title` ,
				`frontend_title` ,
				`page` ,
				`context` ,
				`priority` ,
				`visible_frontend` ,
				`author` ,
				`timestamp` ,
				`sort`
				)";
			$sql .= "VALUES (";
			$sql .= "NULL ,  '".$_POST['group_name']."',  
				'".$_POST['group_frt_name']."',  
				'".$_POST['page']."',  
				'".$_POST['context']."',  
				'".$_POST['priority']."',  
				'".$_POST['group_visible']."',  
				'".$current_user->ID."',
				'".time()."',  
				NULL";
			$sql .= ");";
			$result = "Gruppe erfolgreich angelgt";
		}// if exist
		elseif( $_GET['action'] == 'edit' ){
			$sql = "UPDATE  `".$this->db_prefix."groups` SET  `title` =  '".$_POST['group_name']."', ";
			$sql .= "`frontend_title` = '".$_POST['group_frt_name']."', "; 
			$sql .= "`page` = '".$_POST['page']."', ";
			$sql .= "`context` = '".$_POST['context']."', ";
			$sql .= "`priority` = '".$_POST['priority']."', ";
			$sql .= "`visible_frontend` = '".$_POST['group_visible']."', ";
			$sql .= "`author` = '".$current_user->ID."', ";
			$sql .= "`timestamp` = '".time()."' ";
			$sql .= "WHERE  `".$this->db_prefix."groups`.`id` =".$_GET['group'];
			$result = "Gruppe erfolgreich bearbeitet";
		}
		if(  $this->db->query( $sql ) )
			return array( "result" => true, "context" => $result );
	}
}
?>